unit u_SelectComPort;

{$mode objfpc}{$H+}

// Todo: zoek uit welke poorten niet in gebruik zijn.

interface

uses
  Classes, SysUtils, FileUtil, SdpoSerial, Forms, Controls, Graphics, Dialogs,
  StdCtrls, Registry;

type

  { TFrmSelectComPort }

  TFrmSelectComPort = class(TForm)
    ButtCancel: TButton;
    ButtSelect: TButton;
    EditPortNumber: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    SerialPort: TSdpoSerial;
    procedure ButtCancelClick(Sender: TObject);
    procedure ButtSelectClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Select(var PortNumber: integer);
    private
    { private declarations }
  public
    { public declarations }
  end;

var
  FrmSelectComPort: TFrmSelectComPort;

implementation

{$R *.lfm}

// From:  http://forum.lazarus.freepascal.org/index.php?topic=16616.0

function GetSerialPortNamesExt: string;
var
  reg  : TRegistry;
  l,v  : TStringList;
  n    : integer;
  pn,fn: string;

function findFriendlyName(key: string; port: string): string;
var
  r : TRegistry;
  k : TStringList;
  i : Integer;
  ck: string;
  rs: string;
begin
  r := TRegistry.Create;
  k := TStringList.Create;

  r.RootKey := HKEY_LOCAL_MACHINE;
  r.OpenKeyReadOnly(key);
  r.GetKeyNames(k);
  r.CloseKey;

  try
    for i := 0 to k.Count - 1 do
    begin
      ck := key + k[i] + '\'; // current key
      // looking for "PortName" stringvalue in "Device Parameters" subkey
      if r.OpenKeyReadOnly(ck + 'Device Parameters') then
      begin
        if r.ReadString('PortName') = port then
        begin
          //Memo1.Lines.Add('--> ' + ck);
          r.CloseKey;
          r.OpenKeyReadOnly(ck);
          rs := r.ReadString('FriendlyName');
          Break;
        end // if r.ReadString('PortName') = port ...
      end  // if r.OpenKeyReadOnly(ck + 'Device Parameters') ...
      // keep looking on subkeys for "PortName"
      else // if not r.OpenKeyReadOnly(ck + 'Device Parameters') ...
      begin
        if r.OpenKeyReadOnly(ck) and r.HasSubKeys then
        begin
          rs := findFriendlyName(ck, port);
          if rs <> '' then Break;
        end; // if not (r.OpenKeyReadOnly(ck) and r.HasSubKeys) ...
      end; // if not r.OpenKeyReadOnly(ck + 'Device Parameters') ...
    end; // for i := 0 to k.Count - 1 ...
    result := rs;
  finally
    r.Free;
    k.Free;
  end; // try ...
end; // function findFriendlyName ...

begin
v      := TStringList.Create;
l      := TStringList.Create;
reg    := TRegistry.Create;
Result := '';

try
  reg.RootKey := HKEY_LOCAL_MACHINE;
  if reg.OpenKeyReadOnly('HARDWARE\DEVICEMAP\SERIALCOMM') then
  begin
    reg.GetValueNames(l);

    for n := 0 to l.Count - 1 do
    begin
      pn := reg.ReadString(l[n]);
      fn := findFriendlyName('\System\CurrentControlSet\Enum\', pn);
      v.Add(pn + ' = '+ fn);
      FrmSelectComPort.Memo1.lines.add (pn + ' = ' + fn);
    end; // for n := 0 to l.Count - 1 ...

    Result := v.CommaText;
  end; // if reg.OpenKeyReadOnly('HARDWARE\DEVICEMAP\SERIALCOMM') ...
finally
  reg.Free;
  v.Free;
end; // try ...
end;

{ TFrmSelectComPort }

var Done: boolean;
    PortSelected: integer;

procedure TFrmSelectComPort.Select(var PortNumber: integer);
begin
  FrmSelectComPort.show;
  PortSelected := PortNumber;
  Done := false;
  repeat Application.ProcessMessages until Done;
  PortNumber := PortSelected;
  FrmSelectComPort.hide;
end;

procedure TFrmSelectComPort.ButtCancelClick(Sender: TObject);
begin
  Done := true;
end;

procedure TFrmSelectComPort.ButtSelectClick(Sender: TObject);
var
  Temp: string;
begin
  Temp := EditPortNumber.text;
  val (Temp, PortSelected);
  Done := true;
end;

procedure TFrmSelectComPort.FormCreate(Sender: TObject);
begin
	//Memo1.lines.clear;
  GetSerialPortNamesExt;
end;

end.

